#
# spec file for package apache2-mod_zrkadlo (Version 1.0)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define apxs /usr/sbin/apxs2
%define apache apache2
%define apache_libexecdir %(%{apxs} -q LIBEXECDIR)
%define apache_sysconfdir %(%{apxs} -q SYSCONFDIR)
%define apache_includedir %(%{apxs} -q INCLUDEDIR)
%define apache_serverroot %(%{apxs} -q PREFIX)
%define apache_localstatedir %(%{apxs} -q LOCALSTATEDIR)
%define apache_mmn        %(MMN=$(%{apxs} -q LIBEXECDIR)_MMN; test -x $MMN && $MMN)
Name:           apache2-mod_zrkadlo
Summary:        A download redirector
BuildRequires:  apache2-devel apache2-prefork GeoIP GeoIP-devel apache2-webthings-collection
BuildRequires:  apache2-mod_memcache
BuildRequires:  python-devel
Version:        2.2
Release:        3.33
License:        Apache License 2.0
Group:          Productivity/Networking/Web/Servers
#Source1:        mod_zrkadlo.c
Requires:       apache2 %{apache_mmn} 
#
# for mod_form
Requires:       apache2-webthings-collection
Requires:       apache2-mod_memcache
#
# for the tools:
Requires:       python-mysql python-sqlobject python-cmdln perl-Config-IniFiles
#
Autoreqprov:    on
#
# svn export 'https://forgesvn1.novell.com/svn/opensuse/trunk/tools/download-redirector-v2' download-redirector-v2; tar czf download-redirector-v2.tar.gz download-redirector-v2
Source:         download-redirector-v2.tar.gz
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%{!?python_sitelib: %define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%description
This apache module redirects clients to mirror servers, using an SQL backend.

The package contains also 
* tools to maintain the mirror database
* mirror monitoring
* mirror scanning

(The tools should be split into a subpackage in fact...)

Author: Peter Poeml <poeml@suse.de>

%prep
%setup -n download-redirector-v2

%build
cd mod_zrkadlo
%{apxs} -c -lGeoIP -Wc,"-Wall -g" mod_zrkadlo.c
gcc $RPM_OPT_FLAGS -Wall -lGeoIP -o geoiplookup_continent geoiplookup_continent.c
cd ../mod_autoindex_mb
%{apxs} -c -Wc,"-Wall -g" mod_autoindex_mb.c
cd ../mirrordoctor
CFLAGS="%{optflags}" \
%{__python} setup.py build


%install
mkdir -p $RPM_BUILD_ROOT/%{apache_libexecdir}
cp -p mod_zrkadlo/.libs/mod_zrkadlo.so $RPM_BUILD_ROOT/%{apache_libexecdir}
cp -p mod_autoindex_mb/.libs/mod_autoindex_mb.so $RPM_BUILD_ROOT/%{apache_libexecdir}
install -D -m 755 mod_zrkadlo/geoiplookup_continent $RPM_BUILD_ROOT/%{_bindir}/geoiplookup_continent
# tools
install -D -m 755 tools/set_mirror_score $RPM_BUILD_ROOT/%{_bindir}/set_mirror_score
install -D -m 755 tools/rsyncinfo.py $RPM_BUILD_ROOT/%{_bindir}/rsyncinfo
install -D -m 755 tools/rsyncusers $RPM_BUILD_ROOT/%{_bindir}/rsyncusers
install -D -m 755 tools/metalink-hasher.py $RPM_BUILD_ROOT/%{_bindir}/metalink-hasher
install -D -m 755 tools/geoip-lite-update $RPM_BUILD_ROOT/%{_bindir}/geoip-lite-update
install -D -m 755 scanner/scanner.pl $RPM_BUILD_ROOT/%{_bindir}/scanner
install -D -m 755 mirrorprobe/mirrorprobe.py $RPM_BUILD_ROOT/%{_bindir}/mirrorprobe
# compat for previous name
ln -s mirrorprobe $RPM_BUILD_ROOT/%{_bindir}/pingd
cd mirrordoctor
%{__python} setup.py install --prefix=%{_prefix} --root %{buildroot}
ln -s mirrordoctor.py %{buildroot}/%{_bindir}/mirrordoctor
ln -s mirrordoctor.py %{buildroot}/%{_bindir}/mb



%files
%defattr(-,root,root)
%{apache_libexecdir}/*.so
%doc ABOUT BUGS INSTALL THANKS FAQ TODO NEWS
%doc mod_autoindex_mb/NOTICE
%doc mod_zrkadlo/*.conf
%doc sql
%{_bindir}/*
%{python_sitelib}/*

%changelog
* Sat Nov 22 2008 poeml@suse.de
- update to r5679:
  * scanner: make the usage of md5 hashes optional, and disable it
    by default
  * mb tool (mirrordoctor): rework file subcommand
  * remove md5 support from mod_zrkadlo
* Tue Nov 18 2008 poeml@suse.de
- update to r5623:
  add interim support for queries that don't use the extra hashes
  to look up files in the database, but access them directly by
  filename. This could eventually serve to get rit of the extra
  hash column, and let a database index do the job.
* Sun Nov 16 2008 poeml@suse.de
- added shortcut 'mb' for the longish 'mirrordoctor' command
* Sun Nov  9 2008 poeml@suse.de
- update to r5573
  * mod_zrkadlo: avoid false compile warning about comparison with
    string literal
- compile geoiplookup_continent tool with RPM_OPT_FLAGS
* Sun Nov  9 2008 poeml@suse.de
- update to r5570:
  mod_zrkadlo release 2.1:
  * simplified the Apache configuration: It is no longer needed to
    configure a database query. At the same time it's less
    error-prone and avoids trouble if one forgets to update the
    query, when the database schema changes.
  * specific mirrors can be now configured to get only requests
    for files < n bytes
* Mon Nov  3 2008 poeml@suse.de
- update to r5506:
  smallish mirrordoctor updates:
  * when listing files matching a pattern, show actual filename,
    not the pattern
  * add support for editing of the new other_countries database
    field
  * add first stub for mirror tests ('test' subcommand)
* Mon Nov  3 2008 poeml@suse.de
- update to r5498:
  mod_zrkadlo release 2.0:
  * implement better fallback mirror selection. Fallback mirrors
    are now defined in the database (server.other_countries column)
    and used only when no local mirror could be found (fallback).
    The obsolete ZrkadloTreatCountryAs directive has been removed.
  * double-check for empty base URLs of mirrors
* Wed Oct 29 2008 poeml@suse.de
- update to r5469:
  * new subcommand 'mirrordoctor file' for file operations on the
    mirror database. It can list files add add/remove them.
* Tue Oct 28 2008 poeml@suse.de
- update to r5465:
  * new subcommand 'mirrordoctor vacuum' for database pruning.
    Incorporates the functionality of previous /usr/bin/vacuum.
* Mon Oct 27 2008 poeml@suse.de
- update to r5445:
  * add geoip-lite-update, a script to automate updates of the
    GeoIP database
* Mon Oct 27 2008 poeml@suse.de
- update to r5442:
  * fix link to bittorrent resources.
* Mon Oct 27 2008 poeml@suse.de
- update to r5441:
  mod_zrkadlo version 1.9:
  * Check for files ending in .torrent, and if one exists, add a link
    to it into generated metalinks. New directive
    ZrkadloMetalinkTorrentAddMask, which can used to limit this
    additional check to specific files or directories.
  * rewrote HTML mirror list
  * add configurable CSS stylesheet to mirror lists
    (ZrkadloMirrorlistStyleSheet directive)
* Fri Oct 24 2008 poeml@suse.de
- update to r5427:
  * metalink-hasher: add PGP signatures into <verification> block
* Wed Sep 24 2008 poeml@suse.de
- update to r5127:
  * mirrorprobe:
  - make sure that we don't try to access non-existing attribute
    named code when it doesn't exist (like for FTP urls)
* Fri Sep 19 2008 poeml@suse.de
- update to r5090:
  * rsyncusers:
  - new, performant, implementation in Python. Uses Python
    generators, which means it allocates only few memory and
    works similar a Unix pipe. The tool will now transparently
    open uncompressed, gzip or bzip2 compressed files.
* Tue Sep  2 2008 poeml@suse.de
- update to r4855:
  * mod_zrkadlo:
  - implement the redirection exceptions (file too small, mime
    type not allowed to be redirected etc) for transparently
    negotiated metalinks.
  - add Vary header on all transparently negotiated resources.
  - remove depracated negotiation on Accept-Features.
* Fri Aug 29 2008 poeml@suse.de
- update to r4830:
  * scanner:
  - more fixes to deal with more variants of the HTML autoindex breed.
  - append ?F=1 to HTTP requests (autoindex modifier)
  * mirrorprobe:
  - add the name of the mirrorbrain instance to warning mails
  * mod_autoindex_mb: if metalink or mirrorlists are active, add
    our signature
  * update INSTALL for creating new mirrors
* Thu Aug 28 2008 poeml@suse.de
- update to r4800:
  * metalink-hasher:
  - don't drop the <pieces> elements. Our metalinks were lacking
    the length of hash pieces due to this bug. Clients were
    probably ignoring the partial hashes.
  * mirrordoctor list:
  - add --disabled option to show only disable mirrors
  * mirrordoctor scan:
  - leave a comment after successful scanning and enabling
  - add -a|--all option to pass to the scanner
  - remove -f option which is redundant somehow
  * mirrordoctor new:
  - improve usage. The -i option is no longer needed, the
    identifier is simply given as argument to the command. This
    is more in line with the other subcommands.
  - don't print SQL when not in debug mode.
* Wed Aug 27 2008 poeml@suse.de
- update to r4788:
  * mirrordoctor rename: fix the call which looks up mirrors.
    mirrordoctor new: set default values for 'enabled' and
    'status_baseurl', for tables that don't do it
  * mirrorprobe: add newlines before appending stuff to comments;
    don't try to remove stuff from comments, since multiline
    comments are now commonly used.
* Mon Aug 25 2008 poeml@suse.de
- update to r4765:
  * mirrorprobe: fix for another irregularity caused by Nginx web servers
  * scanner: fix forking with multiple instances
  * metalink-hasher: add missing quoting
* Sat Aug 23 2008 poeml@suse.de
- update to r4758:
  scanner improvements:
  - enable to parse HTML table autoindexes.
  - be more robust when detecting autoindexes.
  mirrordoctor fixes:
  - add option to specify path to scanner program
  - fix calling the scanner when no instance has been specified
  - add python-cmdln to Requires
* Fri Aug 22 2008 poeml@suse.de
- update to r4753:
  mirrorprobe: include the instance name into the log messages
* Fri Aug 22 2008 poeml@suse.de
- update to r4752:
  - pingd was renamed to "mirrorprobe".
    And it also deals with multi mirrorbrain instances now.
    In addition, it ignores proxy settings now.
  - simplified interface of the mirrorbrain python module (mb)
  - updated INSTALL docs
* Thu Aug 21 2008 poeml@suse.de
- update to r4731:
  * mod_zrkadlo:
  - add ZrkadloInstance directive that can be set per mirrorbrain
    instance. To be set in server context, thus each instance needs
    a virtual host.
  - include the instance name into memcache keys
  - add new reconnect=0 parameter (that comes with apr-util-1.3.3)
    to mysql driver example configuration (prepared statements are
    gone after reconnection so that it does not make sense to
    reanimate dead connections. See
    https://issues.apache.org/bugzilla/show_bug.cgi?id=45407)
  * scanner:
  - make scanner work with multiple mirrorbrain instances (-b
    option)
  - fixed bnc394470: added 302, 303 and 307 codes to the check
  * mirrordoctor:
  - make it work with multiple mirrorbrain instances
  - list: hide disabled mirrors by default
  - add a rename subcommand
  - when disabling a mirror, set statusBaseurl to zero, so when
    re-enabling the mirror it doesnt' matter if it is not actually
    online.
  * pingd:
  - make sure that the mirror objects always have the response and
    response_code attributes set
  * SQL schema changes:
  - ensure that the identifier column of the mirror table doesn't
    allow duplicates
  - set a default value for the 'enabled' and 'status_baseurl'
    columns in the mirrors table
* Fri Jun 20 2008 poeml@suse.de
- update to r4228:
  * mirrordoctor update:
  - make the commandline simpler -- now it is possible to just
    give a substring of the mirror identifier, instead of the
    full name (or -m)
  - add more options to the 'scan' command
  - add 'score' command
  - add setup.py file to make the the module installable
* Wed Jun 18 2008 poeml@suse.de
- update to r4210:
  * mirror probe (ping script): fix crash when encountering a server
    which replies with broken chunked transfer encoding.
    nginx/0.6.29 does that.  See http://bugs.python.org/issue1205
* Sun Jun 15 2008 poeml@suse.de
- update to r4178:
  * added mirrordoctor, a new commandline tool to maintain mirror
    entries in the redirector database.
  * build with aprutil 1.3, which ships apr_memcache. Thus, the
    latter is not separately available (and required) anymore.
  - Change the code which fetches rows from the query result set to
    do this in random access mode. Although we actually just want
    to access them sequentially, we need to do it this way because
    (at least at with the mysql driver) apr_dbd_get_row() doesn't
    return anything useful anymore if apr_dbd_num_tuples() has been
    called before. With apr-util 1.2.x, it worked nevertheless, but
    it doesn't with 1.3.
  * For wildcard mirrors (Content Delivery Networks), set their
    country and region to that of the client, so it turns up as
    useful data which the client understands in mirrorlists or
    metalinks.
  - enhance the metalink-hasher tool in two ways:
  - make it possible to run it on a subdirectory only
  - make it possible to work with different base directories --
    which is useful if content is living in a stage area, but you
    want to create the hash pieces already.
  - rsyncusers tool: fix invalid shell code (spaces around '=')
  - add example configuration snippet for mod_memcache
* Tue Jun 10 2008 poeml@suse.de
- build service supports the debuginfo flag in metadata now; remove
  debug_package macro from the specfile therefore.
* Mon Jun  9 2008 poeml@suse.de
- update to r4133:
  - rsyncinfo: add option -S to hide rsync's stderr output
* Mon Jun  2 2008 poeml@suse.de
- update to r4074 (version 0.8):
  - use mod_memcache for the configuration and initialization of
    memcache
  - metalink-hasher script added, to prepare hashes for injection
    into metalink files
  - rsyncusers analysis tool added
  - scanner bugfixes regarding following of redirects
* Wed May 21 2008 poeml@suse.de
- update to r4011:
  - rsyncinfo: fix parsing of rsync module list, when no
    banner is prefixed.
* Tue May 20 2008 poeml@suse.de
- update to r4002:
  - rsyncinfo: tabulate the output
* Wed May 14 2008 poeml@suse.de
- don't package build intermediaries from mod_autoindex
* Fri May  2 2008 poeml@suse.de
- update to r3877:
  - implement a testbed for testing failover with clients using
    text mirror lists; the server will inject broken mirrors at the
    top of the list if the user-agent is
    'getPrimaryFailover-agent/0.1'
  - add rsyncinfo, script to get info on modules of rsync servers
* Wed Apr 30 2008 poeml@suse.de
- update to r3874:
- It was agreed that the new Metalink spec (3.0) will probably use
  RFC 3339 date and time format, but continue to use plain old
  RFC822 format.
- add ZrkadloMetalinkPublisher directive to make name and url in
  publisher data configurable
* Wed Apr 30 2008 poeml@suse.de
- update to r3871:
  - fix issue with requesting metalinks by appending ".metalink":
    the <size> element in metalinks was not filled in correctly
    anymore.
* Sun Apr 27 2008 poeml@suse.de
- update to r3844:
  - now there is another, more natural, way to request a metalink:
    by appending ".metalink" to the filename
  - mod_autoindex_mb now creates links with .metalink appended,
    instead of ?metalink
* Sun Apr 27 2008 poeml@suse.de
- update to r3840:
  - also return metalinks to clients which send
    application/metalink+xml in the Accept request header.
* Mon Apr 21 2008 poeml@suse.de
- update to r3766:
  - mod_zrkadlo 1.7
  - implement a terse text mirrorlist (suitable for e.g.
    http://en.opensuse.org/Libzypp/Failover)
  - allow clients to use RFC2295 Accept-Features header to select
    variants (metalink or mirrorlist-txt)
  - implement ZrkadloMetalinkHashesPathPrefix directive, for
    out-of-tree placement of prepared metalink hashes
  - work on unifying configuration handling of the tools, and make
    them all use /etc/mirrorbrain.conf
* Sat Apr 19 2008 poeml@suse.de
- update to r3752:
  - metalinks:
  - add RFC 2183 header with filename + ".metalink"
  - avoid putting -- (from failed GeoIP lookup) into XML comments,
    since they will be seen as comment terminators
  - add mod_autoindex_mb.c which adds metalinks and mirrorlists to
    generated indexes
* Fri Apr 18 2008 poeml@suse.de
- update to r3749:
  - bypass the redirection exceptions for metalinks, just as for
    mirrorlists
* Thu Apr 17 2008 poeml@suse.de
- update to r3738:
  - make the scanner cope with servers that don't support range
    requests
  - small documentation updates
* Mon Apr  7 2008 poeml@suse.de
- update to r3664:
  - updated THANKS file
  - some documentation updates in ABOUT file
  - remove useless header from mod_zrkadlo response
  - don't include the server_admin email address into the metalink
  - update metalink generator name
- actually install the new THANKS file
* Fri Apr  4 2008 poeml@suse.de
- update to r3634:
- version 1.6
- implement metalink support (http://www.metalinker.org)
- move the block where the single mirror is selected for
  redirection to after the mirrorlist/metalink if branch. It is not
  needed to do that work when metalink or mirrorlist is generated.
- fix a bug I just discovered, but which has been existing since
  ever. I didn't allocate memory for mirror_entry's country_code
  member.
- seed the RNG with getpid() instead of time(), because if the
  server is started several processes are forked off and get the
  same seed. Even though it doesn't play a real role in production,
  it is confusing when working in a debug setting (with many fresh
  starts).
- THANKS file added
* Fri Mar 28 2008 poeml@suse.de
- update to r3592:
  - updated install documentation
  - scanner bugfixes, and HTTP large file capability check
  - fixed http_readdir: passes correct urls to largefile_check
  - scan tests with -j <n>, single servers, -a with mem verification
  - - some aborts in single jpobs occured due to rsync errors
  - - no infinite hangs
  - bugfix: wrong/broken urls were passed to the largefile sanity
    check thus creating false positives
  - http redirects 301 to ftp urls are treated as valid
* Thu Mar  6 2008 poeml@suse.de
- update to r3441:
  - scanner: get rid of hardcoded database credentials
  - integration of sanity checks for large files: large files
    visible on rsync/ftp which can't be downloaded via http are not
    put to the database anymore. Thanks, Jan!
  - set_mirror_score: also use the central conf file
* Thu Mar  6 2008 poeml@suse.de
- add perl-Config-IniFiles to requires
* Thu Feb 28 2008 poeml@suse.de
- add package requires for mod_form, GeoIP, python-mysql,
  python-sqlobject
* Thu Feb 28 2008 poeml@suse.de
- update to r3189:
- the last change (version bump) wasn't actually probagated,
  because I forgot to re-spin the tarball. Here it is.
- install the tools
* Wed Feb 27 2008 poeml@suse.de
- update to r3188:
  - version 1.5
  - updated documentation
  - mirrorlist fixes:
  - ensure that any "clientip" parameter from query string
    represents a valid IP address, in order to keep generated
    HTML clean, so not to allow XSS attacks
  - set character set for HTML output generated to ISO-8859-1
  - fix mirrorlist for the case where no mirror is found. Now an
    empty list is created, instead of sending the file in
    question.
  - when user asks for mirror list, don't DECLINE if the file
    would normally being excluded from redirection by one of the
    various criteria (size, user agent, ...)
  - use GeoIP_id_by_addr() instead of the deprecated (acc. to
    GeoIP.h) GeoIP_country_id_by_addr()
* Wed Feb 13 2008 poeml@suse.de
- update to r3124:
  - add details about the request to the subprocess_env table, so
    then can be logged via a CustomLog:
  - ZRKADLO_FILESIZE, the size of the file which was requested
  - ZRKADLO_COUNTRY_CODE and ZRKADLO_CONTINENT_CODE
  - if a mirror's baseurl doesn't end in '/', append it. Otherwise a
  non-working redirect URL could result.
* Thu Jan 24 2008 poeml@suse.de
- update to r3056:
  - version 1.4
  - refined mirror selection by observing two additional server
    attributes in the database: country_only and region_only.
  - country_only=1 means that a mirror is not willing to receive requests from
    countries other than its own.
  - region_only=1 means that a mirror is not taking redirects from other
    continents, likewise.
    This is good for countries with poor internet connectivity.
* Tue Oct  2 2007 poeml@suse.de
- update to r2298:
  - version 1.3
  - implement ZrkadloExcludeNetwork directive, which allows for
    excluding client IPs from being redirected (simple string
    prefix comparison)
  - implement ZrkadloExcludeIP directive, which matches on IP
    address
  - replace apr_strnatcmp/apr_strnatcasecmp with their simpler
    glibc counterparts
* Mon Oct  1 2007 poeml@suse.de
- update to r2289:
  - implement wildcard country support, useful for content delivery
    networks which should act as a mirror local to all countries
* Thu Sep 20 2007 poeml@suse.de
- update to r2244:
  - version 1.2
  - shorten the SQL query by looking up the base64 encoded md5sum
    of the filename in file_server.path_md5, avoiding an additional
    join on file.name. Needs an adjusted SQL query string, as shown
    in the example mod_zrkadlo.conf.
* Fri Sep 14 2007 poeml@suse.de
- update to r2165
  - version 1.1
  - set ZRKADLO_REDIRECTED and ZRKADLO_NOMIRROR in
    r->subprocess_env, which can be used by a CustomLog
  - the "no mirrors found for %%s" error log message is downgraded
    to APLOG_INFO
  - mod_zrkadlo.conf: give example for logging redirects, and files
    without any mirror
  - updated docs
* Mon Aug 20 2007 poeml@suse.de
- update to r2012
  - add new fields in statistic of memcached 1.2.x
* Tue Mar 13 2007 poeml@suse.de
- update to r1432
  - bump version (1.0)
  - license under Apache License 2.0
  - canonicalize the filename (resolve symlinks in the path) before
    looking it up in the database
  - small fixes in the mirrorlist output
  - remove debug messages about database connection acquisition
* Tue Mar  6 2007 poeml@suse.de
- update to r1387
  - implement mirrorlist query string command to obtain a HTML list
    of all available mirrors
  - add ZrkadloMemcached directive to enable/disable memcache usage
  - add ZrkadloExcludeFileMask
  - unify logging
* Sun Feb 25 2007 poeml@suse.de
- update to r1348
  - make memcached connection pool size configurable
  - make memcached object lifetime configurable
* Wed Feb 21 2007 poeml@suse.de
- add geoiplookup_continent
* Tue Feb 20 2007 poeml@suse.de
- package created
